Index: /gs3-extensions/mat/trunk/web/WEB-INF/web.xml
===================================================================
--- /gs3-extensions/mat/trunk/web/WEB-INF/web.xml	(revision 21942)
+++ /gs3-extensions/mat/trunk/web/WEB-INF/web.xml	(revision 21942)
@@ -0,0 +1,173 @@
+<?xml version="1.0" encoding="ISO-8859-1"?>
+
+<!DOCTYPE web-app 
+    PUBLIC "-//Sun Microsystems, Inc.//DTD Web Application 2.3//EN" 
+    "http://java.sun.com/dtd/web-app_2_3.dtd">
+
+<!-- this is based on a sample web.xml file provided by 
+http://jakarta.apache.org/tomcat/tomcat-4.0-doc/appdev/web.xml.txt
+-->
+<web-app>
+
+
+  <!-- General description of your web application -->
+  
+  <display-name>MAT</display-name>
+  <description>
+    Metadata Analysis Tool.
+  </description>
+  
+  
+  <!-- Context initialization parameters that define shared
+  String constants used within your application, which
+  can be customized by the system administrator who is
+  installing your application.  The values actually
+  assigned to these parameters can be retrieved in a
+  servlet or JSP page by calling:
+  
+  String value =
+  getServletContext().getInitParameter("name");
+  
+  where "name" matches the <param-name> element of
+  one of these initialization parameters.
+  
+  You can define any number of context initialization
+  parameters, including zero.
+  -->
+  
+  <context-param>
+    <param-name>webmaster</param-name>
+    <param-value>greenstone3@list.scms.waikato.ac.nz</param-value>
+    <description>
+      The EMAIL address of the administrator to whom questions
+      and comments about this application should be addressed.
+    </description>
+  </context-param>
+  
+
+  <!-- Servlet definitions for the servlets that make up
+  your web application, including initialization
+  parameters.  With Tomcat, you can also send requests
+  to servlets not listed here with a request like this:
+
+  http://localhost:8080/{context-path}/servlet/{classname}
+  
+  but this usage is not guaranteed to be portable.  It also
+  makes relative references to images and other resources
+  required by your servlet more complicated, so defining
+  all of your servlets (and defining a mapping to them with
+  a servlet-mapping element) is recommended.
+  
+  Servlet initialization parameters can be retrieved in a
+  servlet or JSP page by calling:
+  
+  String value =
+  getServletConfig().getInitParameter("name");
+  
+  where "name" matches the <param-name> element of
+  one of these initialization parameters.
+  
+  You can define any number of servlets, including zero.
+  -->
+
+
+<servlet>
+  <servlet-name>mat</servlet-name>
+  <description>mat</description>
+  <servlet-class>org.greenstone.mat.servlet.MatServlet</servlet-class>
+</servlet>
+
+<servlet-mapping>
+  <servlet-name>mat</servlet-name>
+  <url-pattern>/analyse</url-pattern>
+</servlet-mapping>
+  
+
+<!--
+<filter>
+  <filter-name>UrlRewriteFilter</filter-name>
+  <filter-class>org.tuckey.web.filters.urlrewrite.UrlRewriteFilter</filter-class>
+</filter>
+
+<filter-mapping>
+  <filter-name>UrlRewriteFilter</filter-name>
+  <url-pattern>/*</url-pattern>
+</filter-mapping>
+-->
+ 
+    <!-- Define mappings that are used by the servlet container to
+         translate a particular request URI (context-relative) to a
+         particular servlet.  The examples below correspond to the
+         servlet descriptions above.  Thus, a request URI like:
+
+           http://localhost:8080/{contextpath}/graph
+
+         will be mapped to the "graph" servlet, while a request like:
+
+           http://localhost:8080/{contextpath}/saveCustomer.do
+
+         will be mapped to the "controller" servlet.
+
+ Note: context path is determined by the servlet container - 
+ in Tomcat, specified in server.xml -kjdon
+         You may define any number of servlet mappings, including zero.
+         It is also legal to define more than one mapping for the same
+         servlet, if you wish to.
+    -->
+    <!--
+    
+    <servlet-mapping>
+      <servlet-name>controller</servlet-name>
+      <url-pattern>*.do</url-pattern>
+    </servlet-mapping>
+
+    <servlet-mapping>
+      <servlet-name>graph</servlet-name>
+      <url-pattern>/graph</url-pattern>
+    </servlet-mapping>
+    -->
+    
+
+<!--There is no need for this mapping, I think -->
+
+  <!-- uncomment this if you want to use the SOAPMonitorService. You will also 
+  need to copy the SOAPMonitorApplet*.class files from 
+  gsdl3/comms/soap/axis/web/WEB-INF/classes to the gsdl3/web directory. See the 
+  comms/soap/axis/docs/install.html Appendix for details about how to use this -->
+  <!--
+  <servlet-mapping>
+    <servlet-name>SOAPMonitorService</servlet-name>
+    <url-pattern>/SOAPMonitor</url-pattern>
+  </servlet-mapping>
+  -->
+  <!-- uncomment this if you want the admin servlet -->
+  <!--
+  <servlet-mapping>
+    <servlet-name>AdminServlet</servlet-name>
+    <url-pattern>/servlet/AdminServlet</url-pattern>
+  </servlet-mapping>
+  -->
+
+  <!-- Define the default session timeout for your application,
+  in minutes.  From a servlet or JSP page, you can modify
+  the timeout for a particular session dynamically by using
+  HttpSession.getMaxInactiveInterval(). -->
+
+  <session-config>
+    <session-timeout>30</session-timeout>    <!-- 30 minutes -->
+  </session-config>
+
+  <!-- axis mime-mappings -->
+  <mime-mapping>
+    <extension>wsdl</extension>
+    <mime-type>text/xml</mime-type>
+  </mime-mapping>
+  
+  <mime-mapping>
+    <extension>xsd</extension>
+    <mime-type>text/xml</mime-type>
+  </mime-mapping>
+  
+</web-app>
+
+