Index: /gs3-extensions/mat/trunk/bin/script/mat-colbuild-download.bat
===================================================================
--- /gs3-extensions/mat/trunk/bin/script/mat-colbuild-download.bat	(revision 22041)
+++ /gs3-extensions/mat/trunk/bin/script/mat-colbuild-download.bat	(revision 22042)
@@ -9,7 +9,19 @@
 :: %9 should be the creator
 :: %10 should be the proxy settings
- 
-DEL %8
-cd %6
+
+SET COL_NAME=%1
+SET OAI_URL=%2
+SET CACHE_DIR=%3
+SET MAX_RECORDS=%4
+SET OAI_PREFIX=%5
+SET GS3_ROOT=%6
+SET COL_DIR=%7
+SET LOG_FILE=%8
+SET CREATOR=%9
+::SHIFT
+::SET PROXY=%9
+
+DEL %LOG_FILE%
+cd %GS3_ROOT%
 CALL gs3-setup.bat
 
@@ -19,29 +31,31 @@
 cd bin/script/
 
-perl -S mkcol.pl -gs3mode -collectdir %7 %1
+perl -S mkcol.pl -gs3mode -buildtype lucene -collectdir %COL_DIR% %COL_NAME%
 
 :: need to ensure that OAIPLUG is included
 :: hack the model collection to inclde it
-echo %1 %2 %3 %4 %5 %6 %7 %8 >> %8
+echo %COL_NAME% %OAI_URL% %CACHE_DIR% %MAX_RECORDS% %OAI_PREFIX% %GS3_ROOT% %COL_DIR% %LOG_FILE% >> %LOG_FILE%
 
-if not exist %3 goto else
-RMDIR /S /Q  %3
+if not exist %CACHE_DIR% goto else
+RMDIR /S /Q  %CACHE_DIR%
 goto endif
 :else 
-md %3
+md %CACHE_DIR%
 :endif
 
-echo "Away to download OAI" >> %8
+echo "Away to download OAI" >> %LOG_FILE%
 
-echo %9
+echo %CREATOR%
 
-SET _MyVariable=%9
+SET _CREATOR=%CREATOR%
 
-SET _MyVariable=###%_MyVariable%###
-SET _MyVariable=%_MyVariable:"###=%
-SET _MyVariable=%_MyVariable:###"=%
-SET _MyVariable=%_MyVariable:###=%
+SET _CREATOR=###%_CREATOR%###
+SET _CREATOR=%_CREATOR:"###=%
+SET _CREATOR=%_CREATOR:###"=%
+SET _CREATOR=%_CREATOR:###=%
+
+echo "Away to run downloadfrom.pl with %_CREATOR%"
   
-perl downloadfrom.pl -download_mode OAI -cache_dir %3 -url %2 -max_records %4 -metadata_prefix %5 %_MyVariable%
+perl downloadfrom.pl -download_mode OAI -cache_dir %CACHE_DIR% -url %OAI_URL% -max_records %MAX_RECORDS% -metadata_prefix %OAI_PREFIX% %_CREATOR%
 
 exit
Index: /gs3-extensions/mat/trunk/bin/script/mat-colbuild.bat
===================================================================
--- /gs3-extensions/mat/trunk/bin/script/mat-colbuild.bat	(revision 22041)
+++ /gs3-extensions/mat/trunk/bin/script/mat-colbuild.bat	(revision 22042)
@@ -1,19 +1,19 @@
 :: %1 should be the collection name
-:: %2 should be the oai URL
-:: %3 should be the cache directory
-:: %4 should be the max records
-:: %5 should be the OAI metadata prefix
-:: %6 should be GS3 root
-:: %7 should be the collection directory
-:: %8 should be the log file
-:: %9 should be the hostname:port
+:: %2 should be the cache directory
+:: %3 should be GS3 root
+:: %4 should be the collection directory
+:: %5 should be the log file
+:: %6 should be the hostname:port
 
-:: %GS3_ROOT=%6
-:: %COLLECT_DIR=%7
-:: %LOG_FILE=%8
+SET COL_NAME=%1
+SET CACHE_DIR=%2
+SET GS3_ROOT=%3
+SET COL_DIR=%4
+SET LOG_FILE=%5
+SET HOST_PORT=%6
 
 :: check we are still in the right directories
 
-cd %6
+cd %GS3_ROOT%
 CALL gs3-setup.bat
 
@@ -24,5 +24,7 @@
 echo "Away to build" 
 
-perl build -indextype lucene -site localsite -collectdir %7 -log_events -download file://%3 %1
+XCOPY %CACHE_DIR%\* %COL_DIR%\%COL_NAME%\import /s /i /y
+
+perl -S incremental-rebuild.pl -site localsite -collectdir %COL_DIR% %COL_NAME%
 
 echo "Build finished ...." 
@@ -38,19 +40,19 @@
 :: :endif
 
-echo "Away to convert from Greenstone 2 to Greenstone 3"  >> %8
+echo "Away to convert from Greenstone 2 to Greenstone 3"  >> %LOG_FILE%
 echo "Away to convert from Greenstone 2 to Greenstone 3" 
 
-cd %6
+cd %GS3_ROOT%
 cd bin/script/
 
-perl convert_coll_from_gs2.pl -collectdir %7 %1 
+::perl convert_coll_from_gs2.pl -collectdir %7 %1 
 
-echo "Away to reconfigure Greenstone 3 server"  >> %8
+echo "Away to reconfigure Greenstone 3 server"  >> %LOG_FILE%
 echo "Away to reconfigure Greenstone 3 server" 
 
 :: wget -O /tmp/mat5.html "http://localhost:8090/greenstone3/library?a=s&sa=c" 
-wget -O %3/mat-reconfigure.html "http://%9/greenstone3/library?a=s&sa=c" 
+wget -O %CACHE_DIR%/mat-reconfigure.html "http://%HOST_PORT%/greenstone3/library?a=s&sa=c" 
 
-echo "Done"  >> %8
+echo "Done"  >> %LOG_FILE%
 echo "Done" 
 
Index: /gs3-extensions/mat/trunk/src/org/greenstone/mat/servlet/MatServlet.java
===================================================================
--- /gs3-extensions/mat/trunk/src/org/greenstone/mat/servlet/MatServlet.java	(revision 22041)
+++ /gs3-extensions/mat/trunk/src/org/greenstone/mat/servlet/MatServlet.java	(revision 22042)
@@ -39,5 +39,5 @@
     private String proxyHostContent = "";
     private String proxyPortContent = "";
-    //private String collection_creator = "";
+    private String collection_creator = "";
     private String proxyUserName= "";
     private String proxyUserPassword = "";
@@ -561,5 +561,5 @@
 		alist.add(collectDir);
 		alist.add(logFile);
-		//alist.add(collection_creator);
+		alist.add(collection_creator);
 		alist.add(proxy_settings);
 		String[] arrays = new String[alist.size()];