Index: /main/trunk/greenstone2/macros/amharic.dm
===================================================================
--- /main/trunk/greenstone2/macros/amharic.dm	(revision 22051)
+++ /main/trunk/greenstone2/macros/amharic.dm	(revision 22052)
@@ -452,4 +452,5 @@
 
 _textsimplesearch_ [l=am] {ááá á _indexselection_ _If_(_jselection_,áš _jselection_ )_If_(_gselection_,á  _gselection_ á°ášá )_If_(_nselection_,á  _nselection_ ááá ) ášááá¶á¹ _querytypeselection_ ášá«á _If_(_sfselection_,\,_allowformbreak_ ášááááá áá€áµ á  _sfselection_ áá°á­á°á­)}  
+_textsimplesqlsearch_ [l=am] {ááá á _indexselection_ _If_(_jselection_,áš _jselection_ )_If_(_gselection_,á  _gselection_ á°ášá )_If_(_nselection_,á  _nselection_ ááá ) ášááá¶á¹ _querytypeselection_ ášá«á _If_(_sqlsfselection_,\,_allowformbreak_ ášááááá áá€áµ á  _sqlsfselection_ áá°á­á°á­)}  
 
 _textadvancedsearch_ [l=am] {ááá _indexselection_ _If_(_jselection_,áš _jselection_ )_If_(_gselection_,á  _gselection_ á°ášá )_If_(_nselection_,á  _nselection_ááá ) _querytypeselection_ áá á­á
@@ -459,6 +460,8 @@
 
 _textadvancedlucenesearch_ [l=am] {ááá _indexselection__If_(_jselection_, áš _jselection_)_If_(_gselection_, á  _gselection_ á°ášá)_If_(_nselection_, á  _nselection_ ááá)_If_(_sfselection_,\,_allowformbreak_ áá€á±á á  _sfselection_\ á°á­á°á­,) á }  
+_textadvancedsqlsearch_ [l=am] {ááá _indexselection__If_(_jselection_, áš _jselection_)_If_(_gselection_, á  _gselection_ á°ášá)_If_(_nselection_, á  _nselection_ ááá)_If_(_sqlsfselection_,\,_allowformbreak_ áá€á±á á  _sqlsfselection_\ á°á­á°á­,) á }  
 
 _textformsimplesearch_ [l=am] {ááá _If_(_jselection_, _jselection_)_If_(_gformselection_, á  _gformselection_ á°ášá)_If_(_nselection_, á  _nselection_ ááá)_If_(_sfselection_,\, áá€á±á á  _sfselection_ á á°á­á°á­ \,) áš _formquerytypesimpleselection_ áš }  
+_textformsimplesearchsql_ [l=am] {ááá _If_(_jselection_, _jselection_)_If_(_gformselection_, á  _gformselection_ á°ášá)_If_(_nselection_, á  _nselection_ ááá)_If_(_sqlsfselection_,\, áá€á±á á  _sqlsfselection_ á á°á­á°á­ \,) áš _formquerytypesimpleselection_ áš }  
 
 _textformadvancedsearchmgpp_ [l=am] {ááá _If_(_jselection_,_jselection_ )_If_(_gformselection_,á  _gformselection_ á°ášá )_If_(_nselection_,á  _nselection_ ááá )á¥á áá€á±á á  _formquerytypeadvancedselection_ á
@@ -466,4 +469,5 @@
 
 _textformadvancedsearchlucene_ [l=am] {ááá _If_(_jselection_, _jselection_)_If_(_gformselection_,  á  _gformselection_ á°ášá)_If_(_nselection_, á  _nselection_ ááá)_If_(_sfselection_,\, áá€á±á á  _sfselection_ áá°á­áµá­\,) á}  
+_textformadvancedsearchsql_ [l=am] {ááá _If_(_jselection_, _jselection_)_If_(_gformselection_,  á  _gformselection_ á°ášá)_If_(_nselection_, á  _nselection_ ááá)_If_(_sqlsfselection_,\, áá€á±á á  _sqlsfselection_ áá°á­áµá­\,) á}  
 
 _textnojsformwarning_ [l=am] {ááµá áááá«á€ á¥ášá°á ááá­ á£áá ášáµášááœ áá ááµá¥ áá« áµá­áªááµ á¥áá³á­á°á« á°á°ááá¢ <br> ášá
Index: /main/trunk/greenstone2/macros/chinese.dm
===================================================================
--- /main/trunk/greenstone2/macros/chinese.dm	(revision 22051)
+++ /main/trunk/greenstone2/macros/chinese.dm	(revision 22052)
@@ -436,4 +436,6 @@
 _textadvancedlucenesearch_ [l=zh] {æ¥è¯¢_indexselection__If_(_jselection_,ïŒå
 ³èäº_jselection_)_If_(_gselection_,ïŒäº_gselection_çº§å«)_If_(_nselection_,ïŒåäº_nselection_è¯­)_If_(_sfselection_,\,_allowformbreak_ïŒæ_sfselection_æåºç»æ\,) }  
+_textadvancedsqlsearch_ [l=zh] {æ¥è¯¢_indexselection__If_(_jselection_,ïŒå
+³èäº_jselection_)_If_(_gselection_,ïŒäº_gselection_çº§å«)_If_(_nselection_,ïŒåäº_nselection_è¯­)_If_(_sqlsfselection_,\,_allowformbreak_ïŒæ_sqlsfselection_æåºç»æ\,) }  
 
 _textformsimplesearch_ [l=zh] {_If_(_jselection_, _jselection_ )_If_(_gformselection_,at _gformselection_ level )_If_(_nselection_,in _nselection_ language )ä»¥ _formquerytypesimpleselection_ æ¥è¯¢}
@@ -443,4 +445,5 @@
 
 _textformadvancedsearchlucene_ [l=zh] {æ¥è¯¢_If_(_jselection_,_jselection_)_If_(_gformselection_,ïŒäº_gformselection_çº§å«)_If_(_nselection_,ïŒåäº_nselection_è¯­)_If_(_sfselection_,\,ïŒæ _sfselection_æåºç»æ\,)}  
+_textformadvancedsearchsql_ [l=zh] {æ¥è¯¢_If_(_jselection_,_jselection_)_If_(_gformselection_,ïŒäº_gformselection_çº§å«)_If_(_nselection_,ïŒåäº_nselection_è¯­)_If_(_sqlsfselection_,\,ïŒæ _sqlsfselection_æåºç»æ\,)}  
 
 _textnojsformwarning_ [l=zh] {è­ŠåïŒæšæµè§åšçJavascriptè¢«çŠçšäºã <br>èŠäœ¿çšæ¥è¯¢åèœïŒè¯·å¯çšå®ã}
Index: /main/trunk/greenstone2/macros/dari.dm
===================================================================
--- /main/trunk/greenstone2/macros/dari.dm	(revision 22051)
+++ /main/trunk/greenstone2/macros/dari.dm	(revision 22052)
@@ -578,4 +578,5 @@
 
 _textformadvancedsearchlucene_ [l=prs] {Ø¬Ø³ØªØ¬ÙÛ _If_(_jselection_, _jselection_)_If_(_gformselection_,  Ø¯Ø± _gformselection_ level)_If_(_nselection_, Ø¯Ø± Ø²ØšØ§Ù _nselection_ language)_If_(_sfselection_,\,  ØšÙ ØªØ±ØªÛØš _sfselection_\,)  ØšØ±Ø§Û }  
+_textformadvancedsearchsql_ [l=prs] {Ø¬Ø³ØªØ¬ÙÛ _If_(_jselection_, _jselection_)_If_(_gformselection_,  Ø¯Ø± _gformselection_ level)_If_(_nselection_, Ø¯Ø± Ø²ØšØ§Ù _nselection_ language)_If_(_sqlsfselection_,\,  ØšÙ ØªØ±ØªÛØš _sqlsfselection_\,)  ØšØ±Ø§Û }  
 
 _textnojsformwarning_ [l=prs] {ØªØ°Ú¯Ø± : Ø¬Ø§ÙØ§ Ø§Ø³Ú©Ø±ÛÙŸØª Ø¯Ø± Ù
Index: /main/trunk/greenstone2/macros/gaelic.dm
===================================================================
--- /main/trunk/greenstone2/macros/gaelic.dm	(revision 22051)
+++ /main/trunk/greenstone2/macros/gaelic.dm	(revision 22052)
@@ -398,4 +398,5 @@
 
 _textadvancedlucenesearch_ [l=gd] {Lorg _indexselection__If_(_jselection_, de _jselection_)_If_(_gselection_, aig _gselection_ Ã¬re)_If_(_nselection_, ann _nselection_ cÃ nain)_If_(_sfselection_,\,_allowformbreak_ sorting results by _sfselection_\,) air  }  
+_textadvancedsqlsearch_ [l=gd] {Lorg _indexselection__If_(_jselection_, de _jselection_)_If_(_gselection_, aig _gselection_ Ã¬re)_If_(_nselection_, ann _nselection_ cÃ nain)_If_(_sqlsfselection_,\,_allowformbreak_ sorting results by _sqlsfselection_\,) air  }  
 
 _textformsimplesearch_ [l=gd] {Lorg _If_(_jselection_,_jselection_ )_If_(_gformselection_,aig _gformselection_ Ã¬re )_If_(_nselection_,ann _nselection_ cÃ nain )airson _formquerytypesimpleselection_ de}  
@@ -404,4 +405,5 @@
 
 _textformadvancedsearchlucene_ [l=gd] {Lorg _If_(_jselection_, _jselection_)_If_(_gformselection_,  aig _gformselection_ Ã¬re)_If_(_nselection_, ann _nselection_ cÃ nain)_If_(_sfselection_,\, sorting results by _sfselection_\,) air  }  
+_textformadvancedsearchsql_ [l=gd] {Lorg _If_(_jselection_, _jselection_)_If_(_gformselection_,  aig _gformselection_ Ã¬re)_If_(_nselection_, ann _nselection_ cÃ nain)_If_(_sqlsfselection_,\, sorting results by _sqlsfselection_\,) air  }  
 
 _textnojsformwarning_ [l=gd] {Rabhadh: cha tugadh comas do Javascript anns do shealladair. <br>Ma tha thu airson lorg chrutha a chleachdadh, thoir comas dha.}  
Index: /main/trunk/greenstone2/macros/gujarati.dm
===================================================================
--- /main/trunk/greenstone2/macros/gujarati.dm	(revision 22051)
+++ /main/trunk/greenstone2/macros/gujarati.dm	(revision 22052)
@@ -420,4 +420,5 @@
 
 _textsimplesearch_ [l=gu] {Search in _indexselection__If_(_jselection_, associated with _jselection_)_If_(_gselection_, at _gselection_ level )_If_(_nselection_, in _nselection_ language)_If_(_sfselection_,\,_allowformbreak_ sorting results by _sfselection_) for _querytypeselection_ of the words}  
+_textsimplesqlsearch_ [l=gu] {Search in _indexselection__If_(_jselection_, associated with _jselection_)_If_(_gselection_, at _gselection_ level )_If_(_nselection_, in _nselection_ language)_If_(_sqlsfselection_,\,_allowformbreak_ sorting results by _sqlsfselection_) for _querytypeselection_ of the words}  
 
 _textadvancedsearch_ [l=gu] {Search in_indexselection__If_(_jselection_, associated with _jselection_)_If_(_gselection_, at _gselection_ level)_If_(_nselection_, in _nselection_ language) using _querytypeselection_ query}  
@@ -426,8 +427,10 @@
 
 _textadvancedlucenesearch_ [l=gu] {Search in_indexselection__If_(_jselection_, associated with _jselection_)_If_(_gselection_, at _gselection_ level )_If_(_nselection_, in _nselection_ language)_If_(_sfselection_,\,_allowformbreak_ sorting results by _sfselection_\,) for }  
+_textadvancedsqlsearch_ [l=gu] {Search in_indexselection__If_(_jselection_, associated with _jselection_)_If_(_gselection_, at _gselection_ level )_If_(_nselection_, in _nselection_ language)_If_(_sqlsfselection_,\,_allowformbreak_ sorting results by _sqlsfselection_\,) for }  
 
 # the space after "Search" is required, otherwise no space between "Search" and "in"
 
 _textformsimplesearch_ [l=gu] {Search _If_(_jselection_, in _jselection_)_If_(_gformselection_, at _gformselection_ level)_If_(_nselection_, in _nselection_ language)_If_(_sfselection_,\, sorting results by _sfselection_\,) for _formquerytypesimpleselection_ of}  
+_textformsimplesearchsql_ [l=gu] {Search _If_(_jselection_, in _jselection_)_If_(_gformselection_, at _gformselection_ level)_If_(_nselection_, in _nselection_ language)_If_(_sqlsfselection_,\, sorting results by _sqlsfselection_\,) for _formquerytypesimpleselection_ of}  
 
 _textformadvancedsearchmgpp_ [l=gu] {Search _If_(_jselection_, in _jselection_)_If_(_gformselection_, at _gformselection_ level)_If_(_nselection_, in _nselection_ language),  àª®àªŸàªà«, àª
@@ -435,4 +438,5 @@
 
 _textformadvancedsearchlucene_ [l=gu] {Search _If_(_jselection_, in _jselection_)_If_(_gformselection_, at _gformselection_ level)_If_(_nselection_, in _nselection_ language)_If_(_sfselection_,\, sorting results by _sfselection_\,) for}  
+_textformadvancedsearchsql_ [l=gu] {Search _If_(_jselection_, in _jselection_)_If_(_gformselection_, at _gformselection_ level)_If_(_nselection_, in _nselection_ language)_If_(_sqlsfselection_,\, sorting results by _sqlsfselection_\,) for}  
 
 _textnojsformwarning_ [l=gu] {àªà«àª€àªµàª£à«àª àªàªŸàªµàªŸàªžà«àªà«àª°àª¿àªªà«àª àª€àª®àªŸàª°àªŸ àªµà«àª¬ àª¬à«àª°àªŸàªàªàª°àª®àªŸàª àªžàªà«àª·àª® àªà«.<br>àª«à«àª°à«àª® àª¶à«àª§àªšà« àªàªªàª¯à«àª àªàª°àªµàªŸ, àª€à«àªšà« àªžàªà«àª·àª® àª¬àªšàªŸàªµà«.}  
Index: /main/trunk/greenstone2/macros/russian.dm
===================================================================
--- /main/trunk/greenstone2/macros/russian.dm	(revision 22051)
+++ /main/trunk/greenstone2/macros/russian.dm	(revision 22052)
@@ -398,4 +398,5 @@
 
 _textadvancedlucenesearch_ [l=ru] {ÐÐŸÐžÑÐº Ð² _indexselection__If_(_jselection_, ÑÐ²ÑÐ·Ð°ÑÑ Ñ _jselection_)_If_(_gselection_, ÑÑÐŸÐ²ÐµÐœÑ _gselection_)_If_(_nselection_, ÑÐ·ÑÐº: _nselection_ )_If_(_sfselection_,\,_allowformbreak_ Ðž ÐŸÑÑÐŸÑÑÐžÑÐŸÐ²Ð°ÑÑ ÑÐµÐ·ÑÐ»ÑÑÐ°ÑÑ Ð¿ÐŸ _sfselection_\,) ÐŽÐ»Ñ}  
+_textadvancedsqlsearch_ [l=ru] {ÐÐŸÐžÑÐº Ð² _indexselection__If_(_jselection_, ÑÐ²ÑÐ·Ð°ÑÑ Ñ _jselection_)_If_(_gselection_, ÑÑÐŸÐ²ÐµÐœÑ _gselection_)_If_(_nselection_, ÑÐ·ÑÐº: _nselection_ )_If_(_sqlsfselection_,\,_allowformbreak_ Ðž ÐŸÑÑÐŸÑÑÐžÑÐŸÐ²Ð°ÑÑ ÑÐµÐ·ÑÐ»ÑÑÐ°ÑÑ Ð¿ÐŸ _sqlsfselection_\,) ÐŽÐ»Ñ}  
 
 # the space after "Search" is required, otherwise no space between "Search" and "in"
@@ -406,4 +407,5 @@
 
 _textformadvancedsearchlucene_ [l=ru] {ÐÐŸÐžÑÐº Ð¿ÐŸ _If_(_jselection_, Ð¿ÐŸ _jselection_)_If_(_gformselection_, ÐœÐ° ÑÑÐŸÐ²ÐœÐµ _gformselection_ )_If_(_nselection_, ÑÐ·ÑÐº: _nselection_ )_If_(_sfselection_,\, ÐŸÑÑÐŸÑÑÐžÑÐŸÐ²Ð°ÑÑ ÑÐµÐ·ÑÐ»ÑÑÐ°ÑÑ Ð¿ÐŸ _sfselection_\,) ÐŽÐ»Ñ}  
+_textformadvancedsearchsql_ [l=ru] {ÐÐŸÐžÑÐº Ð¿ÐŸ _If_(_jselection_, Ð¿ÐŸ _jselection_)_If_(_gformselection_, ÐœÐ° ÑÑÐŸÐ²ÐœÐµ _gformselection_ )_If_(_nselection_, ÑÐ·ÑÐº: _nselection_ )_If_(_sqlsfselection_,\, ÐŸÑÑÐŸÑÑÐžÑÐŸÐ²Ð°ÑÑ ÑÐµÐ·ÑÐ»ÑÑÐ°ÑÑ Ð¿ÐŸ _sqlsfselection_\,) ÐŽÐ»Ñ}  
 
 _textnojsformwarning_ [l=ru] {ÐÑÐµÐŽÑÐ¿ÑÐµÐ¶ÐŽÐµÐœÐžÐµ: Javascript Ð¿ÐŸÐ²ÑÐµÐ¶ÐŽÐµÐœ ÐœÐ° ÐÐ°ÑÐµÐŒ Ð²ÐµÐ±-Ð±ÑÐ°ÑÐ·ÐµÑÐµ. <br>Ð§ÑÐŸÐ±Ñ ÐžÑÐ¿ÐŸÐ»ÑÐ·ÐŸÐ²Ð°ÑÑ ÑÐŸÑÐŒÑ Ð¿ÐŸÐžÑÐºÐ°, Ð¿ÐŸÐ¶Ð°Ð»ÑÐ¹ÑÑÐ°, ÑÐ°Ð·ÑÐµÑÐžÑÐµ ÑÑÐŸ.}
Index: /main/trunk/greenstone2/macros/thai.dm
===================================================================
--- /main/trunk/greenstone2/macros/thai.dm	(revision 22051)
+++ /main/trunk/greenstone2/macros/thai.dm	(revision 22052)
@@ -377,4 +377,5 @@
 
 _textsimplesearch_ [l=th] {àžà¹àžàž«àž²à¹àž _indexselection_ _If_(_jselection_ àžàžµà¹àžªàž±àž¡àžàž±àžàžà¹àžàž±àž _jselection_ ) _If_(_gselection_ àžàžµà¹àž£àž°àžàž±àž _gselection_ )_If_(_nselection_ à¹àžàž àž²àž©àž² _nselection_ )_If_(_sfselection_,\,_allowformbreak_ à¹àž£àžµàž¢àžàž¥àž³àžàž±àžàžàž¥àž¥àž±àžàžà¹àžà¹àž§àž¢ _sfselection_) àžªàž³àž«àž£àž±àž _querytypeselection_ àžàž­àžàžàž³
+_textsimplesqlsearch_ [l=th] {àžà¹àžàž«àž²à¹àž _indexselection_ _If_(_jselection_ àžàžµà¹àžªàž±àž¡àžàž±àžàžà¹àžàž±àž _jselection_ ) _If_(_gselection_ àžàžµà¹àž£àž°àžàž±àž _gselection_ )_If_(_nselection_ à¹àžàž àž²àž©àž² _nselection_ )_If_(_sqlsfselection_,\,_allowformbreak_ à¹àž£àžµàž¢àžàž¥àž³àžàž±àžàžàž¥àž¥àž±àžàžà¹àžà¹àž§àž¢ _sqlsfselection_) àžªàž³àž«àž£àž±àž _querytypeselection_ àžàž­àžàžàž³
 }  
 
@@ -384,10 +385,13 @@
 
 _textadvancedlucenesearch_ [l=th] {àžà¹àžàž«àž²à¹àž _indexselection__If_(_jselection_ àžàžµà¹àžªàž±àž¡àžàž±àžàžà¹àžàž±àž _jselection_)_If_(_gselection_ àžàžµà¹àž£àž°àžàž±àž _gselection_ )_If_(_nselection_ à¹àžàž àž²àž©àž² _nselection_)_If_(_sfselection_\,_allowformbreak_ à¹àž£àžµàž¢àžàž¥àž³àžàž±àžàžàž¥àž¥àž±àžàžà¹àžà¹àž§àž¢ _sfselection_\,) àžà¹àž§àž¢àžàž³àž§à¹àž²}  
+_textadvancedsqlsearch_ [l=th] {àžà¹àžàž«àž²à¹àž _indexselection__If_(_jselection_ àžàžµà¹àžªàž±àž¡àžàž±àžàžà¹àžàž±àž _jselection_)_If_(_gselection_ àžàžµà¹àž£àž°àžàž±àž _gselection_ )_If_(_nselection_ à¹àžàž àž²àž©àž² _nselection_)_If_(_sqlsfselection_\,_allowformbreak_ à¹àž£àžµàž¢àžàž¥àž³àžàž±àžàžàž¥àž¥àž±àžàžà¹àžà¹àž§àž¢ _sqlsfselection_\,) àžà¹àž§àž¢àžàž³àž§à¹àž²}  
 
 _textformsimplesearch_ [l=th] {àžà¹àžàž«àž²_If_(_jselection_ à¹àž _jselection_)_If_(_gformselection_ àžàžµà¹àž£àž°àžàž±àž _gformselection_)_If_(_nselection_ à¹àžàž àž²àž©àž² _nselection_)_If_(_sfselection_\ à¹àž¥àž°à¹àž£àžµàž¢àžàž¥àž³àžàž±àžàžàž¥àž¥àž±àžàžà¹àžà¹àž§àž¢ _sfselection_\,) àžªàž³àž«àž£àž±àž _formquerytypesimpleselection_ of " }  
+_textformsimplesearchsql_ [l=th] {àžà¹àžàž«àž²_If_(_jselection_ à¹àž _jselection_)_If_(_gformselection_ àžàžµà¹àž£àž°àžàž±àž _gformselection_)_If_(_nselection_ à¹àžàž àž²àž©àž² _nselection_)_If_(_sqlsfselection_\ à¹àž¥àž°à¹àž£àžµàž¢àžàž¥àž³àžàž±àžàžàž¥àž¥àž±àžàžà¹àžà¹àž§àž¢ _sqlsfselection_\,) àžªàž³àž«àž£àž±àž _formquerytypesimpleselection_ of " }  
 
 _textformadvancedsearchmgpp_ [l=th] {àžà¹àžàž«àž² _If_(_jselection_ à¹àž _jselection_ )_If_(_gformselection_àžàžµà¹àž£àž°àžàž±àž _gformselection_)_If_(_nselection_à¹àžàž àž²àž©àž² _nselection_ ) à¹àž¥àž°à¹àžªàžàžàžàž¥àž¥àž±àžàžà¹àžàž²àž¡àž¥àž³àžàž±àž _formquerytypeadvancedselection_ àžà¹àž§àž¢àžàž³àž§à¹àž²}  
 
 _textformadvancedsearchlucene_ [l=th] {àžà¹àžàž«àž²_If_(_jselection_ à¹àž _jselection_)_If_(_gformselection_,  àžàžµà¹àž£àž°àžàž±àž _gformselection_)_If_(_nselection_ à¹àžàž àž²àž©àž² _nselection_)_If_(_sfselection_\, à¹àž£àžµàž¢àžàž¥àž³àžàž±àžàžàž¥àž¥àž±àžàžà¹àžà¹àž§àž¢ _sfselection_\,) àžà¹àž§àž¢àžàž³àž§à¹àž²}  
+_textformadvancedsearchsql_ [l=th] {àžà¹àžàž«àž²_If_(_jselection_ à¹àž _jselection_)_If_(_gformselection_,  àžàžµà¹àž£àž°àžàž±àž _gformselection_)_If_(_nselection_ à¹àžàž àž²àž©àž² _nselection_)_If_(_sqlsfselection_\, à¹àž£àžµàž¢àžàž¥àž³àžàž±àžàžàž¥àž¥àž±àžàžà¹àžà¹àž§àž¢ _sqlsfselection_\,) àžà¹àž§àž¢àžàž³àž§à¹àž²}  
 
 _textnojsformwarning_ [l=th] {àžàž³à¹àžàž·àž­àž: à¹àž§à¹àžà¹àžàž£àž²àž§à¹àžàž­àž£à¹àžàž­àžàžàžžàžàžàžŽàžàžàž²àž£à¹àžà¹àžàž²àžàžàž²àž§àž²àžªàžàž£àžŽàžàžà¹  <br>à¹àž¡àž·à¹àž­àžà¹àž­àžàžàž²àž£àžà¹àžàž«àž²à¹àžàž¢à¹àžà¹à¹àžàžàžàž­àž£à¹àž¡ àžàž£àžžàžàž²à¹àžàžŽàžà¹àžà¹àžàž²àžàžàž²àž§àž²àžªàžàž£àžŽàžàžà¹	}  