Index: main/trunk/greenstone2/runtime-src/configure
===================================================================
--- main/trunk/greenstone2/runtime-src/configure	(revision 21440)
+++ main/trunk/greenstone2/runtime-src/configure	(revision 22058)
@@ -310,5 +310,5 @@
 
 ac_subdirs_all="$ac_subdirs_all packages"
-ac_subst_vars='SHELL PATH_SEPARATOR PACKAGE_NAME PACKAGE_TARNAME PACKAGE_VERSION PACKAGE_STRING PACKAGE_BUGREPORT exec_prefix prefix program_transform_name bindir sbindir libexecdir datadir sysconfdir sharedstatedir localstatedir libdir includedir oldincludedir infodir mandir build_alias host_alias target_alias DEFS ECHO_C ECHO_N ECHO_T LIBS PACKAGE VERSION USE_FASTCGI USE_LANGACTION USE_CORBA MICO_DIR USE_Z3950 USE_YAZ ENABLE_ACCENTFOLD USE_SQLITE USE_APACHE_HTTPD ENABLE_MG ENABLE_MGPP ENABLE_LUCENE LDFLAGS CFLAGS CC CPPFLAGS ac_ct_CC EXEEXT OBJEXT CXX CXXFLAGS ac_ct_CXX AWK YACC build build_cpu build_vendor build_os host host_cpu host_vendor host_os target target_cpu target_vendor target_os INSTALL_PROGRAM INSTALL_SCRIPT INSTALL_DATA LN_S SET_MAKE RANLIB ac_ct_RANLIB COMPAT32BITFLAGS MICO_VER CPP EGREP U ANSI2KNR ALLOCA LIBOBJS STATIC gsdlos MODULEDIRS subdirs LTLIBOBJS'
+ac_subst_vars='SHELL PATH_SEPARATOR PACKAGE_NAME PACKAGE_TARNAME PACKAGE_VERSION PACKAGE_STRING PACKAGE_BUGREPORT exec_prefix prefix program_transform_name bindir sbindir libexecdir datadir sysconfdir sharedstatedir localstatedir libdir includedir oldincludedir infodir mandir build_alias host_alias target_alias DEFS ECHO_C ECHO_N ECHO_T LIBS PACKAGE VERSION USE_FASTCGI USE_LANGACTION USE_CORBA MICO_DIR USE_Z3950 USE_YAZ USE_JDBM USE_GDBM ENABLE_ACCENTFOLD USE_SQLITE USE_APACHE_HTTPD ENABLE_MG ENABLE_MGPP ENABLE_LUCENE LDFLAGS CFLAGS CC CPPFLAGS ac_ct_CC EXEEXT OBJEXT CXX CXXFLAGS ac_ct_CXX AWK YACC build build_cpu build_vendor build_os host host_cpu host_vendor host_os target target_cpu target_vendor target_os INSTALL_PROGRAM INSTALL_SCRIPT INSTALL_DATA LN_S SET_MAKE RANLIB ac_ct_RANLIB COMPAT32BITFLAGS MICO_VER CPP EGREP U ANSI2KNR ALLOCA LIBOBJS STATIC gsdlos MODULEDIRS subdirs LTLIBOBJS'
 ac_subst_files=''
 
@@ -857,4 +857,6 @@
   --enable-z3950          Enable Z39.50 client support
   --disable-yaz           Disable YAZ compilation
+  --disable-jdbm        Disable JDBM compilation
+  --disable-gdbm        Disable GDBM compilation
   --disable-accentfold    Disable Accent Folding for MGPP
   --disable-sqlite        Disable SQLite support
@@ -1359,12 +1361,17 @@
 if test "${enable_corba+set}" = set; then
   enableval="$enable_corba"
+  USE_CORBA=$enableval
+else
+  USE_CORBA=no
+fi;
+if test $USE_CORBA = "yes" -o $USE_CORBA = "1" ; then
   USE_CORBA=1
+  cat >>confdefs.h <<\_ACEOF
+#define USE_CORBA
+_ACEOF
+
 else
   USE_CORBA=0
-fi;
-cat >>confdefs.h <<_ACEOF
-#define USE_CORBA $USE_CORBA
-_ACEOF
-
+fi
 
 
@@ -1386,27 +1393,71 @@
 if test "${enable_z3950+set}" = set; then
   enableval="$enable_z3950"
+  USE_Z3950=$enableval
+else
+  USE_Z3950=no
+fi;
+if test $USE_Z3950 = "yes" -o $USE_Z3950 = "1" ; then
   USE_Z3950=1
+  cat >>confdefs.h <<\_ACEOF
+#define USE_Z3950
+_ACEOF
+
 else
   USE_Z3950=0
-fi;
-if test USE_Z3950 = 1; then
-cat >>confdefs.h <<\_ACEOF
-#define USE_Z3950 $USE_Z3950
-_ACEOF
-
-
-fi
+fi
+
 
 # Check whether --enable-yaz or --disable-yaz was given.
 if test "${enable_yaz+set}" = set; then
   enableval="$enable_yaz"
+  USE_YAZ=$enableval
+else
+  USE_YAZ=yes
+fi;
+if test $USE_YAZ = "yes" -o $USE_YAZ = "1" ; then
+  USE_YAZ=1
+  cat >>confdefs.h <<\_ACEOF
+#define USE_YAZ
+_ACEOF
+
+else
   USE_YAZ=0
-else
-  USE_YAZ=1
+fi
+
+
+# Check whether --enable-jdbm or --disable-jdbm was given.
+if test "${enable_jdbm+set}" = set; then
+  enableval="$enable_jdbm"
+  USE_JDBM=$enableval
+else
+  USE_JDBM=yes
 fi;
-cat >>confdefs.h <<\_ACEOF
-#define USE_YAZ $USE_YAZ
-_ACEOF
-
+if test $USE_JDBM = "yes" -o $USE_JDBM = "1" ; then
+  USE_JDBM=1
+  cat >>confdefs.h <<\_ACEOF
+#define USE_JDBM
+_ACEOF
+
+else
+  USE_JDBM=0
+fi
+
+
+# Check whether --enable-gdbm or --disable-gdbm was given.
+if test "${enable_gdbm+set}" = set; then
+  enableval="$enable_gdbm"
+  USE_GDBM=$enableval
+else
+  USE_GDBM=yes
+fi;
+if test $USE_GDBM = "yes" -o $USE_GDBM = "1" ; then
+  USE_GDBM=1
+  cat >>confdefs.h <<\_ACEOF
+#define USE_GDBM
+_ACEOF
+
+else
+  USE_GDBM=0
+fi
 
 
@@ -1414,12 +1465,17 @@
 if test "${enable_accentfold+set}" = set; then
   enableval="$enable_accentfold"
+  ENABLE_ACCENTFOLD=$enableval
+else
+  ENABLE_ACCENTFOLD=yes
+fi;
+if test $ENABLE_ACCENTFOLD = "yes" -o $ENABLE_ACCENTFOLD = "1" ; then
+  ENABLE_ACCENTFOLD=1
+  cat >>confdefs.h <<\_ACEOF
+#define ENABLE_ACCENTFOLD
+_ACEOF
+
+else
   ENABLE_ACCENTFOLD=0
-else
-  ENABLE_ACCENTFOLD=1
-fi;
-cat >>confdefs.h <<\_ACEOF
-#define ENABLE_ACCENTFOLD $ENABLE_ACCENTFOLD
-_ACEOF
-
+fi
 
 
@@ -1427,26 +1483,38 @@
 if test "${enable_sqlite+set}" = set; then
   enableval="$enable_sqlite"
+  USE_SQLITE=$enableval
+else
+  USE_SQLITE=yes
+fi;
+if test $USE_SQLITE = "yes" -o $USE_SQLITE = "1" ; then
+  USE_SQLITE=1
+  cat >>confdefs.h <<\_ACEOF
+#define USE_SQLITE
+_ACEOF
+
+else
   USE_SQLITE=0
-else
-  USE_SQLITE=1
-fi;
-cat >>confdefs.h <<\_ACEOF
-#define USE_SQLITE $USE_SQLITE
-_ACEOF
-
-
-
-# Check whether --enable-apache-httpd or --disable-apache-httpd was given.
+fi
+
+
+if test -d runtime-src; then
+   # Check whether --enable-apache-httpd or --disable-apache-httpd was given.
 if test "${enable_apache_httpd+set}" = set; then
   enableval="$enable_apache_httpd"
-  USE_APACHE_HTTPD=1
-else
-  USE_APACHE_HTTPD=0
+  USE_APACHE_HTTPD=$enableval
+else
+  USE_APACHE_HTTPD=no
 fi;
-cat >>confdefs.h <<\_ACEOF
-#define USE_APACHE_HTTPD $USE_APACHE_HTTPD
-_ACEOF
-
-
+   if test $USE_APACHE_HTTPD = "yes" -o $USE_APACHE_HTTPD = "1" ; then
+     USE_APACHE_HTTPD=1
+     cat >>confdefs.h <<\_ACEOF
+#define USE_APACHE_HTTPD
+_ACEOF
+
+   else
+     USE_APACHE_HTTPD=0
+   fi
+
+fi
 
 # Check whether --enable-mg or --disable-mg was given.
@@ -7906,4 +7974,6 @@
 s,@USE_Z3950@,$USE_Z3950,;t t
 s,@USE_YAZ@,$USE_YAZ,;t t
+s,@USE_JDBM@,$USE_JDBM,;t t
+s,@USE_GDBM@,$USE_GDBM,;t t
 s,@ENABLE_ACCENTFOLD@,$ENABLE_ACCENTFOLD,;t t
 s,@USE_SQLITE@,$USE_SQLITE,;t t